package cn.kdan.pdf.tech.core.mapper.ext;

import cn.kdan.pdf.tech.core.mapper.DevicesMapper;
import cn.kdan.pdf.tech.core.pojo.vo.VppDeviceVO;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author tangxiangan
 */
public interface ExtVppDeviceMapper extends DevicesMapper {

    /**
     * 获取某些团队的设备使用详情
     *
     * @param teamIds  团队id
     * @param productId 产品id
     * @param status 设备状态
     * @param queryString 名字邮箱或者设备uuid
     * @return VppDeviceVO
     */
    List<VppDeviceVO> listWithInfo (
                                    @Param("teamIds") List<String> teamIds,
                                    @Param("productId") Integer productId,
                                    @Param("status") Integer status,
                                    @Param("queryString") String queryString);

}
