package cn.kdan.pdf.tech.core.model;

import java.io.Serializable;
import java.util.Date;

public class Devices implements Serializable {
    private String id;

    private Integer appId;

    private String subscriptionId;

    private String uniqueSn;

    private Integer status;

    private String model;

    private String os;

    private String language;

    private String timeZone;

    private String appVersion;

    private Date createdAt;

    private Date updatedAt;

    private Date endUpAt;

    private String memberId;

    private String cdkey;

    private Integer platform;

    private Date canceledDate;

    private Date activatedDate;

    private String companyId;

    private Short isVpp;

    private static final long serialVersionUID = 1L;

    public String getId() {
        return id;
    }

    public Devices withId(String id) {
        this.setId(id);
        return this;
    }

    public void setId(String id) {
        this.id = id;
    }

    public Integer getAppId() {
        return appId;
    }

    public Devices withAppId(Integer appId) {
        this.setAppId(appId);
        return this;
    }

    public void setAppId(Integer appId) {
        this.appId = appId;
    }

    public String getSubscriptionId() {
        return subscriptionId;
    }

    public Devices withSubscriptionId(String subscriptionId) {
        this.setSubscriptionId(subscriptionId);
        return this;
    }

    public void setSubscriptionId(String subscriptionId) {
        this.subscriptionId = subscriptionId;
    }

    public String getUniqueSn() {
        return uniqueSn;
    }

    public Devices withUniqueSn(String uniqueSn) {
        this.setUniqueSn(uniqueSn);
        return this;
    }

    public void setUniqueSn(String uniqueSn) {
        this.uniqueSn = uniqueSn;
    }

    public Integer getStatus() {
        return status;
    }

    public Devices withStatus(Integer status) {
        this.setStatus(status);
        return this;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    public String getModel() {
        return model;
    }

    public Devices withModel(String model) {
        this.setModel(model);
        return this;
    }

    public void setModel(String model) {
        this.model = model;
    }

    public String getOs() {
        return os;
    }

    public Devices withOs(String os) {
        this.setOs(os);
        return this;
    }

    public void setOs(String os) {
        this.os = os;
    }

    public String getLanguage() {
        return language;
    }

    public Devices withLanguage(String language) {
        this.setLanguage(language);
        return this;
    }

    public void setLanguage(String language) {
        this.language = language;
    }

    public String getTimeZone() {
        return timeZone;
    }

    public Devices withTimeZone(String timeZone) {
        this.setTimeZone(timeZone);
        return this;
    }

    public void setTimeZone(String timeZone) {
        this.timeZone = timeZone;
    }

    public String getAppVersion() {
        return appVersion;
    }

    public Devices withAppVersion(String appVersion) {
        this.setAppVersion(appVersion);
        return this;
    }

    public void setAppVersion(String appVersion) {
        this.appVersion = appVersion;
    }

    public Date getCreatedAt() {
        return createdAt;
    }

    public Devices withCreatedAt(Date createdAt) {
        this.setCreatedAt(createdAt);
        return this;
    }

    public void setCreatedAt(Date createdAt) {
        this.createdAt = createdAt;
    }

    public Date getUpdatedAt() {
        return updatedAt;
    }

    public Devices withUpdatedAt(Date updatedAt) {
        this.setUpdatedAt(updatedAt);
        return this;
    }

    public void setUpdatedAt(Date updatedAt) {
        this.updatedAt = updatedAt;
    }

    public Date getEndUpAt() {
        return endUpAt;
    }

    public Devices withEndUpAt(Date endUpAt) {
        this.setEndUpAt(endUpAt);
        return this;
    }

    public void setEndUpAt(Date endUpAt) {
        this.endUpAt = endUpAt;
    }

    public String getMemberId() {
        return memberId;
    }

    public Devices withMemberId(String memberId) {
        this.setMemberId(memberId);
        return this;
    }

    public void setMemberId(String memberId) {
        this.memberId = memberId;
    }

    public String getCdkey() {
        return cdkey;
    }

    public Devices withCdkey(String cdkey) {
        this.setCdkey(cdkey);
        return this;
    }

    public void setCdkey(String cdkey) {
        this.cdkey = cdkey;
    }

    public Integer getPlatform() {
        return platform;
    }

    public Devices withPlatform(Integer platform) {
        this.setPlatform(platform);
        return this;
    }

    public void setPlatform(Integer platform) {
        this.platform = platform;
    }

    public Date getCanceledDate() {
        return canceledDate;
    }

    public Devices withCanceledDate(Date canceledDate) {
        this.setCanceledDate(canceledDate);
        return this;
    }

    public void setCanceledDate(Date canceledDate) {
        this.canceledDate = canceledDate;
    }

    public Date getActivatedDate() {
        return activatedDate;
    }

    public Devices withActivatedDate(Date activatedDate) {
        this.setActivatedDate(activatedDate);
        return this;
    }

    public void setActivatedDate(Date activatedDate) {
        this.activatedDate = activatedDate;
    }

    public String getCompanyId() {
        return companyId;
    }

    public Devices withCompanyId(String companyId) {
        this.setCompanyId(companyId);
        return this;
    }

    public void setCompanyId(String companyId) {
        this.companyId = companyId;
    }

    public Short getIsVpp() {
        return isVpp;
    }

    public Devices withIsVpp(Short isVpp) {
        this.setIsVpp(isVpp);
        return this;
    }

    public void setIsVpp(Short isVpp) {
        this.isVpp = isVpp;
    }

    @Override
    public boolean equals(Object that) {
        if (this == that) {
            return true;
        }
        if (that == null) {
            return false;
        }
        if (getClass() != that.getClass()) {
            return false;
        }
        Devices other = (Devices) that;
        return (this.getId() == null ? other.getId() == null : this.getId().equals(other.getId()))
            && (this.getAppId() == null ? other.getAppId() == null : this.getAppId().equals(other.getAppId()))
            && (this.getSubscriptionId() == null ? other.getSubscriptionId() == null : this.getSubscriptionId().equals(other.getSubscriptionId()))
            && (this.getUniqueSn() == null ? other.getUniqueSn() == null : this.getUniqueSn().equals(other.getUniqueSn()))
            && (this.getStatus() == null ? other.getStatus() == null : this.getStatus().equals(other.getStatus()))
            && (this.getModel() == null ? other.getModel() == null : this.getModel().equals(other.getModel()))
            && (this.getOs() == null ? other.getOs() == null : this.getOs().equals(other.getOs()))
            && (this.getLanguage() == null ? other.getLanguage() == null : this.getLanguage().equals(other.getLanguage()))
            && (this.getTimeZone() == null ? other.getTimeZone() == null : this.getTimeZone().equals(other.getTimeZone()))
            && (this.getAppVersion() == null ? other.getAppVersion() == null : this.getAppVersion().equals(other.getAppVersion()))
            && (this.getCreatedAt() == null ? other.getCreatedAt() == null : this.getCreatedAt().equals(other.getCreatedAt()))
            && (this.getUpdatedAt() == null ? other.getUpdatedAt() == null : this.getUpdatedAt().equals(other.getUpdatedAt()))
            && (this.getEndUpAt() == null ? other.getEndUpAt() == null : this.getEndUpAt().equals(other.getEndUpAt()))
            && (this.getMemberId() == null ? other.getMemberId() == null : this.getMemberId().equals(other.getMemberId()))
            && (this.getCdkey() == null ? other.getCdkey() == null : this.getCdkey().equals(other.getCdkey()))
            && (this.getPlatform() == null ? other.getPlatform() == null : this.getPlatform().equals(other.getPlatform()))
            && (this.getCanceledDate() == null ? other.getCanceledDate() == null : this.getCanceledDate().equals(other.getCanceledDate()))
            && (this.getActivatedDate() == null ? other.getActivatedDate() == null : this.getActivatedDate().equals(other.getActivatedDate()))
            && (this.getCompanyId() == null ? other.getCompanyId() == null : this.getCompanyId().equals(other.getCompanyId()))
            && (this.getIsVpp() == null ? other.getIsVpp() == null : this.getIsVpp().equals(other.getIsVpp()));
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((getId() == null) ? 0 : getId().hashCode());
        result = prime * result + ((getAppId() == null) ? 0 : getAppId().hashCode());
        result = prime * result + ((getSubscriptionId() == null) ? 0 : getSubscriptionId().hashCode());
        result = prime * result + ((getUniqueSn() == null) ? 0 : getUniqueSn().hashCode());
        result = prime * result + ((getStatus() == null) ? 0 : getStatus().hashCode());
        result = prime * result + ((getModel() == null) ? 0 : getModel().hashCode());
        result = prime * result + ((getOs() == null) ? 0 : getOs().hashCode());
        result = prime * result + ((getLanguage() == null) ? 0 : getLanguage().hashCode());
        result = prime * result + ((getTimeZone() == null) ? 0 : getTimeZone().hashCode());
        result = prime * result + ((getAppVersion() == null) ? 0 : getAppVersion().hashCode());
        result = prime * result + ((getCreatedAt() == null) ? 0 : getCreatedAt().hashCode());
        result = prime * result + ((getUpdatedAt() == null) ? 0 : getUpdatedAt().hashCode());
        result = prime * result + ((getEndUpAt() == null) ? 0 : getEndUpAt().hashCode());
        result = prime * result + ((getMemberId() == null) ? 0 : getMemberId().hashCode());
        result = prime * result + ((getCdkey() == null) ? 0 : getCdkey().hashCode());
        result = prime * result + ((getPlatform() == null) ? 0 : getPlatform().hashCode());
        result = prime * result + ((getCanceledDate() == null) ? 0 : getCanceledDate().hashCode());
        result = prime * result + ((getActivatedDate() == null) ? 0 : getActivatedDate().hashCode());
        result = prime * result + ((getCompanyId() == null) ? 0 : getCompanyId().hashCode());
        result = prime * result + ((getIsVpp() == null) ? 0 : getIsVpp().hashCode());
        return result;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", id=").append(id);
        sb.append(", appId=").append(appId);
        sb.append(", subscriptionId=").append(subscriptionId);
        sb.append(", uniqueSn=").append(uniqueSn);
        sb.append(", status=").append(status);
        sb.append(", model=").append(model);
        sb.append(", os=").append(os);
        sb.append(", language=").append(language);
        sb.append(", timeZone=").append(timeZone);
        sb.append(", appVersion=").append(appVersion);
        sb.append(", createdAt=").append(createdAt);
        sb.append(", updatedAt=").append(updatedAt);
        sb.append(", endUpAt=").append(endUpAt);
        sb.append(", memberId=").append(memberId);
        sb.append(", cdkey=").append(cdkey);
        sb.append(", platform=").append(platform);
        sb.append(", canceledDate=").append(canceledDate);
        sb.append(", activatedDate=").append(activatedDate);
        sb.append(", companyId=").append(companyId);
        sb.append(", isVpp=").append(isVpp);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }
}