package cn.kdan.pdf.tech.core.model;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

public class Products implements Serializable {
    private Integer id;

    private String name;

    private Integer appId;

    private String code;

    private Double price;

    private String forVersion;

    private String forPeriod;

    private Integer maxDeviceNum;

    private String description;

    private Date createdAt;

    private Date updatedAt;

    private Double cnyPrice;

    private Integer parentProductId;

    private String sonIds;

    private BigDecimal displayPrice;

    private BigDecimal cnyDisplayPrice;

    private static final long serialVersionUID = 1L;

    public Integer getId() {
        return id;
    }

    public Products withId(Integer id) {
        this.setId(id);
        return this;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public Products withName(String name) {
        this.setName(name);
        return this;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Integer getAppId() {
        return appId;
    }

    public Products withAppId(Integer appId) {
        this.setAppId(appId);
        return this;
    }

    public void setAppId(Integer appId) {
        this.appId = appId;
    }

    public String getCode() {
        return code;
    }

    public Products withCode(String code) {
        this.setCode(code);
        return this;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public Double getPrice() {
        return price;
    }

    public Products withPrice(Double price) {
        this.setPrice(price);
        return this;
    }

    public void setPrice(Double price) {
        this.price = price;
    }

    public String getForVersion() {
        return forVersion;
    }

    public Products withForVersion(String forVersion) {
        this.setForVersion(forVersion);
        return this;
    }

    public void setForVersion(String forVersion) {
        this.forVersion = forVersion;
    }

    public String getForPeriod() {
        return forPeriod;
    }

    public Products withForPeriod(String forPeriod) {
        this.setForPeriod(forPeriod);
        return this;
    }

    public void setForPeriod(String forPeriod) {
        this.forPeriod = forPeriod;
    }

    public Integer getMaxDeviceNum() {
        return maxDeviceNum;
    }

    public Products withMaxDeviceNum(Integer maxDeviceNum) {
        this.setMaxDeviceNum(maxDeviceNum);
        return this;
    }

    public void setMaxDeviceNum(Integer maxDeviceNum) {
        this.maxDeviceNum = maxDeviceNum;
    }

    public String getDescription() {
        return description;
    }

    public Products withDescription(String description) {
        this.setDescription(description);
        return this;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public Date getCreatedAt() {
        return createdAt;
    }

    public Products withCreatedAt(Date createdAt) {
        this.setCreatedAt(createdAt);
        return this;
    }

    public void setCreatedAt(Date createdAt) {
        this.createdAt = createdAt;
    }

    public Date getUpdatedAt() {
        return updatedAt;
    }

    public Products withUpdatedAt(Date updatedAt) {
        this.setUpdatedAt(updatedAt);
        return this;
    }

    public void setUpdatedAt(Date updatedAt) {
        this.updatedAt = updatedAt;
    }

    public Double getCnyPrice() {
        return cnyPrice;
    }

    public Products withCnyPrice(Double cnyPrice) {
        this.setCnyPrice(cnyPrice);
        return this;
    }

    public void setCnyPrice(Double cnyPrice) {
        this.cnyPrice = cnyPrice;
    }

    public Integer getParentProductId() {
        return parentProductId;
    }

    public Products withParentProductId(Integer parentProductId) {
        this.setParentProductId(parentProductId);
        return this;
    }

    public void setParentProductId(Integer parentProductId) {
        this.parentProductId = parentProductId;
    }

    public String getSonIds() {
        return sonIds;
    }

    public Products withSonIds(String sonIds) {
        this.setSonIds(sonIds);
        return this;
    }

    public void setSonIds(String sonIds) {
        this.sonIds = sonIds;
    }

    public BigDecimal getDisplayPrice() {
        return displayPrice;
    }

    public Products withDisplayPrice(BigDecimal displayPrice) {
        this.setDisplayPrice(displayPrice);
        return this;
    }

    public void setDisplayPrice(BigDecimal displayPrice) {
        this.displayPrice = displayPrice;
    }

    public BigDecimal getCnyDisplayPrice() {
        return cnyDisplayPrice;
    }

    public Products withCnyDisplayPrice(BigDecimal cnyDisplayPrice) {
        this.setCnyDisplayPrice(cnyDisplayPrice);
        return this;
    }

    public void setCnyDisplayPrice(BigDecimal cnyDisplayPrice) {
        this.cnyDisplayPrice = cnyDisplayPrice;
    }

    @Override
    public boolean equals(Object that) {
        if (this == that) {
            return true;
        }
        if (that == null) {
            return false;
        }
        if (getClass() != that.getClass()) {
            return false;
        }
        Products other = (Products) that;
        return (this.getId() == null ? other.getId() == null : this.getId().equals(other.getId()))
            && (this.getName() == null ? other.getName() == null : this.getName().equals(other.getName()))
            && (this.getAppId() == null ? other.getAppId() == null : this.getAppId().equals(other.getAppId()))
            && (this.getCode() == null ? other.getCode() == null : this.getCode().equals(other.getCode()))
            && (this.getPrice() == null ? other.getPrice() == null : this.getPrice().equals(other.getPrice()))
            && (this.getForVersion() == null ? other.getForVersion() == null : this.getForVersion().equals(other.getForVersion()))
            && (this.getForPeriod() == null ? other.getForPeriod() == null : this.getForPeriod().equals(other.getForPeriod()))
            && (this.getMaxDeviceNum() == null ? other.getMaxDeviceNum() == null : this.getMaxDeviceNum().equals(other.getMaxDeviceNum()))
            && (this.getDescription() == null ? other.getDescription() == null : this.getDescription().equals(other.getDescription()))
            && (this.getCreatedAt() == null ? other.getCreatedAt() == null : this.getCreatedAt().equals(other.getCreatedAt()))
            && (this.getUpdatedAt() == null ? other.getUpdatedAt() == null : this.getUpdatedAt().equals(other.getUpdatedAt()))
            && (this.getCnyPrice() == null ? other.getCnyPrice() == null : this.getCnyPrice().equals(other.getCnyPrice()))
            && (this.getParentProductId() == null ? other.getParentProductId() == null : this.getParentProductId().equals(other.getParentProductId()))
            && (this.getSonIds() == null ? other.getSonIds() == null : this.getSonIds().equals(other.getSonIds()))
            && (this.getDisplayPrice() == null ? other.getDisplayPrice() == null : this.getDisplayPrice().equals(other.getDisplayPrice()))
            && (this.getCnyDisplayPrice() == null ? other.getCnyDisplayPrice() == null : this.getCnyDisplayPrice().equals(other.getCnyDisplayPrice()));
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((getId() == null) ? 0 : getId().hashCode());
        result = prime * result + ((getName() == null) ? 0 : getName().hashCode());
        result = prime * result + ((getAppId() == null) ? 0 : getAppId().hashCode());
        result = prime * result + ((getCode() == null) ? 0 : getCode().hashCode());
        result = prime * result + ((getPrice() == null) ? 0 : getPrice().hashCode());
        result = prime * result + ((getForVersion() == null) ? 0 : getForVersion().hashCode());
        result = prime * result + ((getForPeriod() == null) ? 0 : getForPeriod().hashCode());
        result = prime * result + ((getMaxDeviceNum() == null) ? 0 : getMaxDeviceNum().hashCode());
        result = prime * result + ((getDescription() == null) ? 0 : getDescription().hashCode());
        result = prime * result + ((getCreatedAt() == null) ? 0 : getCreatedAt().hashCode());
        result = prime * result + ((getUpdatedAt() == null) ? 0 : getUpdatedAt().hashCode());
        result = prime * result + ((getCnyPrice() == null) ? 0 : getCnyPrice().hashCode());
        result = prime * result + ((getParentProductId() == null) ? 0 : getParentProductId().hashCode());
        result = prime * result + ((getSonIds() == null) ? 0 : getSonIds().hashCode());
        result = prime * result + ((getDisplayPrice() == null) ? 0 : getDisplayPrice().hashCode());
        result = prime * result + ((getCnyDisplayPrice() == null) ? 0 : getCnyDisplayPrice().hashCode());
        return result;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", id=").append(id);
        sb.append(", name=").append(name);
        sb.append(", appId=").append(appId);
        sb.append(", code=").append(code);
        sb.append(", price=").append(price);
        sb.append(", forVersion=").append(forVersion);
        sb.append(", forPeriod=").append(forPeriod);
        sb.append(", maxDeviceNum=").append(maxDeviceNum);
        sb.append(", description=").append(description);
        sb.append(", createdAt=").append(createdAt);
        sb.append(", updatedAt=").append(updatedAt);
        sb.append(", cnyPrice=").append(cnyPrice);
        sb.append(", parentProductId=").append(parentProductId);
        sb.append(", sonIds=").append(sonIds);
        sb.append(", displayPrice=").append(displayPrice);
        sb.append(", cnyDisplayPrice=").append(cnyDisplayPrice);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }
}