package cn.kdan.pdf.tech.core.model;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class ProductsExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public ProductsExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Integer value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Integer value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Integer> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andNameIsNull() {
            addCriterion("name is null");
            return (Criteria) this;
        }

        public Criteria andNameIsNotNull() {
            addCriterion("name is not null");
            return (Criteria) this;
        }

        public Criteria andNameEqualTo(String value) {
            addCriterion("name =", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameNotEqualTo(String value) {
            addCriterion("name <>", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameGreaterThan(String value) {
            addCriterion("name >", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameGreaterThanOrEqualTo(String value) {
            addCriterion("name >=", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameLessThan(String value) {
            addCriterion("name <", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameLessThanOrEqualTo(String value) {
            addCriterion("name <=", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameLike(String value) {
            addCriterion("name like", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameNotLike(String value) {
            addCriterion("name not like", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameIn(List<String> values) {
            addCriterion("name in", values, "name");
            return (Criteria) this;
        }

        public Criteria andNameNotIn(List<String> values) {
            addCriterion("name not in", values, "name");
            return (Criteria) this;
        }

        public Criteria andNameBetween(String value1, String value2) {
            addCriterion("name between", value1, value2, "name");
            return (Criteria) this;
        }

        public Criteria andNameNotBetween(String value1, String value2) {
            addCriterion("name not between", value1, value2, "name");
            return (Criteria) this;
        }

        public Criteria andAppIdIsNull() {
            addCriterion("app_id is null");
            return (Criteria) this;
        }

        public Criteria andAppIdIsNotNull() {
            addCriterion("app_id is not null");
            return (Criteria) this;
        }

        public Criteria andAppIdEqualTo(Integer value) {
            addCriterion("app_id =", value, "appId");
            return (Criteria) this;
        }

        public Criteria andAppIdNotEqualTo(Integer value) {
            addCriterion("app_id <>", value, "appId");
            return (Criteria) this;
        }

        public Criteria andAppIdGreaterThan(Integer value) {
            addCriterion("app_id >", value, "appId");
            return (Criteria) this;
        }

        public Criteria andAppIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("app_id >=", value, "appId");
            return (Criteria) this;
        }

        public Criteria andAppIdLessThan(Integer value) {
            addCriterion("app_id <", value, "appId");
            return (Criteria) this;
        }

        public Criteria andAppIdLessThanOrEqualTo(Integer value) {
            addCriterion("app_id <=", value, "appId");
            return (Criteria) this;
        }

        public Criteria andAppIdIn(List<Integer> values) {
            addCriterion("app_id in", values, "appId");
            return (Criteria) this;
        }

        public Criteria andAppIdNotIn(List<Integer> values) {
            addCriterion("app_id not in", values, "appId");
            return (Criteria) this;
        }

        public Criteria andAppIdBetween(Integer value1, Integer value2) {
            addCriterion("app_id between", value1, value2, "appId");
            return (Criteria) this;
        }

        public Criteria andAppIdNotBetween(Integer value1, Integer value2) {
            addCriterion("app_id not between", value1, value2, "appId");
            return (Criteria) this;
        }

        public Criteria andCodeIsNull() {
            addCriterion("code is null");
            return (Criteria) this;
        }

        public Criteria andCodeIsNotNull() {
            addCriterion("code is not null");
            return (Criteria) this;
        }

        public Criteria andCodeEqualTo(String value) {
            addCriterion("code =", value, "code");
            return (Criteria) this;
        }

        public Criteria andCodeNotEqualTo(String value) {
            addCriterion("code <>", value, "code");
            return (Criteria) this;
        }

        public Criteria andCodeGreaterThan(String value) {
            addCriterion("code >", value, "code");
            return (Criteria) this;
        }

        public Criteria andCodeGreaterThanOrEqualTo(String value) {
            addCriterion("code >=", value, "code");
            return (Criteria) this;
        }

        public Criteria andCodeLessThan(String value) {
            addCriterion("code <", value, "code");
            return (Criteria) this;
        }

        public Criteria andCodeLessThanOrEqualTo(String value) {
            addCriterion("code <=", value, "code");
            return (Criteria) this;
        }

        public Criteria andCodeLike(String value) {
            addCriterion("code like", value, "code");
            return (Criteria) this;
        }

        public Criteria andCodeNotLike(String value) {
            addCriterion("code not like", value, "code");
            return (Criteria) this;
        }

        public Criteria andCodeIn(List<String> values) {
            addCriterion("code in", values, "code");
            return (Criteria) this;
        }

        public Criteria andCodeNotIn(List<String> values) {
            addCriterion("code not in", values, "code");
            return (Criteria) this;
        }

        public Criteria andCodeBetween(String value1, String value2) {
            addCriterion("code between", value1, value2, "code");
            return (Criteria) this;
        }

        public Criteria andCodeNotBetween(String value1, String value2) {
            addCriterion("code not between", value1, value2, "code");
            return (Criteria) this;
        }

        public Criteria andPriceIsNull() {
            addCriterion("price is null");
            return (Criteria) this;
        }

        public Criteria andPriceIsNotNull() {
            addCriterion("price is not null");
            return (Criteria) this;
        }

        public Criteria andPriceEqualTo(Double value) {
            addCriterion("price =", value, "price");
            return (Criteria) this;
        }

        public Criteria andPriceNotEqualTo(Double value) {
            addCriterion("price <>", value, "price");
            return (Criteria) this;
        }

        public Criteria andPriceGreaterThan(Double value) {
            addCriterion("price >", value, "price");
            return (Criteria) this;
        }

        public Criteria andPriceGreaterThanOrEqualTo(Double value) {
            addCriterion("price >=", value, "price");
            return (Criteria) this;
        }

        public Criteria andPriceLessThan(Double value) {
            addCriterion("price <", value, "price");
            return (Criteria) this;
        }

        public Criteria andPriceLessThanOrEqualTo(Double value) {
            addCriterion("price <=", value, "price");
            return (Criteria) this;
        }

        public Criteria andPriceIn(List<Double> values) {
            addCriterion("price in", values, "price");
            return (Criteria) this;
        }

        public Criteria andPriceNotIn(List<Double> values) {
            addCriterion("price not in", values, "price");
            return (Criteria) this;
        }

        public Criteria andPriceBetween(Double value1, Double value2) {
            addCriterion("price between", value1, value2, "price");
            return (Criteria) this;
        }

        public Criteria andPriceNotBetween(Double value1, Double value2) {
            addCriterion("price not between", value1, value2, "price");
            return (Criteria) this;
        }

        public Criteria andForVersionIsNull() {
            addCriterion("for_version is null");
            return (Criteria) this;
        }

        public Criteria andForVersionIsNotNull() {
            addCriterion("for_version is not null");
            return (Criteria) this;
        }

        public Criteria andForVersionEqualTo(String value) {
            addCriterion("for_version =", value, "forVersion");
            return (Criteria) this;
        }

        public Criteria andForVersionNotEqualTo(String value) {
            addCriterion("for_version <>", value, "forVersion");
            return (Criteria) this;
        }

        public Criteria andForVersionGreaterThan(String value) {
            addCriterion("for_version >", value, "forVersion");
            return (Criteria) this;
        }

        public Criteria andForVersionGreaterThanOrEqualTo(String value) {
            addCriterion("for_version >=", value, "forVersion");
            return (Criteria) this;
        }

        public Criteria andForVersionLessThan(String value) {
            addCriterion("for_version <", value, "forVersion");
            return (Criteria) this;
        }

        public Criteria andForVersionLessThanOrEqualTo(String value) {
            addCriterion("for_version <=", value, "forVersion");
            return (Criteria) this;
        }

        public Criteria andForVersionLike(String value) {
            addCriterion("for_version like", value, "forVersion");
            return (Criteria) this;
        }

        public Criteria andForVersionNotLike(String value) {
            addCriterion("for_version not like", value, "forVersion");
            return (Criteria) this;
        }

        public Criteria andForVersionIn(List<String> values) {
            addCriterion("for_version in", values, "forVersion");
            return (Criteria) this;
        }

        public Criteria andForVersionNotIn(List<String> values) {
            addCriterion("for_version not in", values, "forVersion");
            return (Criteria) this;
        }

        public Criteria andForVersionBetween(String value1, String value2) {
            addCriterion("for_version between", value1, value2, "forVersion");
            return (Criteria) this;
        }

        public Criteria andForVersionNotBetween(String value1, String value2) {
            addCriterion("for_version not between", value1, value2, "forVersion");
            return (Criteria) this;
        }

        public Criteria andForPeriodIsNull() {
            addCriterion("for_period is null");
            return (Criteria) this;
        }

        public Criteria andForPeriodIsNotNull() {
            addCriterion("for_period is not null");
            return (Criteria) this;
        }

        public Criteria andForPeriodEqualTo(String value) {
            addCriterion("for_period =", value, "forPeriod");
            return (Criteria) this;
        }

        public Criteria andForPeriodNotEqualTo(String value) {
            addCriterion("for_period <>", value, "forPeriod");
            return (Criteria) this;
        }

        public Criteria andForPeriodGreaterThan(String value) {
            addCriterion("for_period >", value, "forPeriod");
            return (Criteria) this;
        }

        public Criteria andForPeriodGreaterThanOrEqualTo(String value) {
            addCriterion("for_period >=", value, "forPeriod");
            return (Criteria) this;
        }

        public Criteria andForPeriodLessThan(String value) {
            addCriterion("for_period <", value, "forPeriod");
            return (Criteria) this;
        }

        public Criteria andForPeriodLessThanOrEqualTo(String value) {
            addCriterion("for_period <=", value, "forPeriod");
            return (Criteria) this;
        }

        public Criteria andForPeriodLike(String value) {
            addCriterion("for_period like", value, "forPeriod");
            return (Criteria) this;
        }

        public Criteria andForPeriodNotLike(String value) {
            addCriterion("for_period not like", value, "forPeriod");
            return (Criteria) this;
        }

        public Criteria andForPeriodIn(List<String> values) {
            addCriterion("for_period in", values, "forPeriod");
            return (Criteria) this;
        }

        public Criteria andForPeriodNotIn(List<String> values) {
            addCriterion("for_period not in", values, "forPeriod");
            return (Criteria) this;
        }

        public Criteria andForPeriodBetween(String value1, String value2) {
            addCriterion("for_period between", value1, value2, "forPeriod");
            return (Criteria) this;
        }

        public Criteria andForPeriodNotBetween(String value1, String value2) {
            addCriterion("for_period not between", value1, value2, "forPeriod");
            return (Criteria) this;
        }

        public Criteria andMaxDeviceNumIsNull() {
            addCriterion("max_device_num is null");
            return (Criteria) this;
        }

        public Criteria andMaxDeviceNumIsNotNull() {
            addCriterion("max_device_num is not null");
            return (Criteria) this;
        }

        public Criteria andMaxDeviceNumEqualTo(Integer value) {
            addCriterion("max_device_num =", value, "maxDeviceNum");
            return (Criteria) this;
        }

        public Criteria andMaxDeviceNumNotEqualTo(Integer value) {
            addCriterion("max_device_num <>", value, "maxDeviceNum");
            return (Criteria) this;
        }

        public Criteria andMaxDeviceNumGreaterThan(Integer value) {
            addCriterion("max_device_num >", value, "maxDeviceNum");
            return (Criteria) this;
        }

        public Criteria andMaxDeviceNumGreaterThanOrEqualTo(Integer value) {
            addCriterion("max_device_num >=", value, "maxDeviceNum");
            return (Criteria) this;
        }

        public Criteria andMaxDeviceNumLessThan(Integer value) {
            addCriterion("max_device_num <", value, "maxDeviceNum");
            return (Criteria) this;
        }

        public Criteria andMaxDeviceNumLessThanOrEqualTo(Integer value) {
            addCriterion("max_device_num <=", value, "maxDeviceNum");
            return (Criteria) this;
        }

        public Criteria andMaxDeviceNumIn(List<Integer> values) {
            addCriterion("max_device_num in", values, "maxDeviceNum");
            return (Criteria) this;
        }

        public Criteria andMaxDeviceNumNotIn(List<Integer> values) {
            addCriterion("max_device_num not in", values, "maxDeviceNum");
            return (Criteria) this;
        }

        public Criteria andMaxDeviceNumBetween(Integer value1, Integer value2) {
            addCriterion("max_device_num between", value1, value2, "maxDeviceNum");
            return (Criteria) this;
        }

        public Criteria andMaxDeviceNumNotBetween(Integer value1, Integer value2) {
            addCriterion("max_device_num not between", value1, value2, "maxDeviceNum");
            return (Criteria) this;
        }

        public Criteria andDescriptionIsNull() {
            addCriterion("description is null");
            return (Criteria) this;
        }

        public Criteria andDescriptionIsNotNull() {
            addCriterion("description is not null");
            return (Criteria) this;
        }

        public Criteria andDescriptionEqualTo(String value) {
            addCriterion("description =", value, "description");
            return (Criteria) this;
        }

        public Criteria andDescriptionNotEqualTo(String value) {
            addCriterion("description <>", value, "description");
            return (Criteria) this;
        }

        public Criteria andDescriptionGreaterThan(String value) {
            addCriterion("description >", value, "description");
            return (Criteria) this;
        }

        public Criteria andDescriptionGreaterThanOrEqualTo(String value) {
            addCriterion("description >=", value, "description");
            return (Criteria) this;
        }

        public Criteria andDescriptionLessThan(String value) {
            addCriterion("description <", value, "description");
            return (Criteria) this;
        }

        public Criteria andDescriptionLessThanOrEqualTo(String value) {
            addCriterion("description <=", value, "description");
            return (Criteria) this;
        }

        public Criteria andDescriptionLike(String value) {
            addCriterion("description like", value, "description");
            return (Criteria) this;
        }

        public Criteria andDescriptionNotLike(String value) {
            addCriterion("description not like", value, "description");
            return (Criteria) this;
        }

        public Criteria andDescriptionIn(List<String> values) {
            addCriterion("description in", values, "description");
            return (Criteria) this;
        }

        public Criteria andDescriptionNotIn(List<String> values) {
            addCriterion("description not in", values, "description");
            return (Criteria) this;
        }

        public Criteria andDescriptionBetween(String value1, String value2) {
            addCriterion("description between", value1, value2, "description");
            return (Criteria) this;
        }

        public Criteria andDescriptionNotBetween(String value1, String value2) {
            addCriterion("description not between", value1, value2, "description");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNull() {
            addCriterion("created_at is null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNotNull() {
            addCriterion("created_at is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtEqualTo(Date value) {
            addCriterion("created_at =", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotEqualTo(Date value) {
            addCriterion("created_at <>", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThan(Date value) {
            addCriterion("created_at >", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("created_at >=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThan(Date value) {
            addCriterion("created_at <", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThanOrEqualTo(Date value) {
            addCriterion("created_at <=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIn(List<Date> values) {
            addCriterion("created_at in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotIn(List<Date> values) {
            addCriterion("created_at not in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtBetween(Date value1, Date value2) {
            addCriterion("created_at between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotBetween(Date value1, Date value2) {
            addCriterion("created_at not between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtIsNull() {
            addCriterion("updated_at is null");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtIsNotNull() {
            addCriterion("updated_at is not null");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtEqualTo(Date value) {
            addCriterion("updated_at =", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtNotEqualTo(Date value) {
            addCriterion("updated_at <>", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtGreaterThan(Date value) {
            addCriterion("updated_at >", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("updated_at >=", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtLessThan(Date value) {
            addCriterion("updated_at <", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtLessThanOrEqualTo(Date value) {
            addCriterion("updated_at <=", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtIn(List<Date> values) {
            addCriterion("updated_at in", values, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtNotIn(List<Date> values) {
            addCriterion("updated_at not in", values, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtBetween(Date value1, Date value2) {
            addCriterion("updated_at between", value1, value2, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtNotBetween(Date value1, Date value2) {
            addCriterion("updated_at not between", value1, value2, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andCnyPriceIsNull() {
            addCriterion("cny_price is null");
            return (Criteria) this;
        }

        public Criteria andCnyPriceIsNotNull() {
            addCriterion("cny_price is not null");
            return (Criteria) this;
        }

        public Criteria andCnyPriceEqualTo(Double value) {
            addCriterion("cny_price =", value, "cnyPrice");
            return (Criteria) this;
        }

        public Criteria andCnyPriceNotEqualTo(Double value) {
            addCriterion("cny_price <>", value, "cnyPrice");
            return (Criteria) this;
        }

        public Criteria andCnyPriceGreaterThan(Double value) {
            addCriterion("cny_price >", value, "cnyPrice");
            return (Criteria) this;
        }

        public Criteria andCnyPriceGreaterThanOrEqualTo(Double value) {
            addCriterion("cny_price >=", value, "cnyPrice");
            return (Criteria) this;
        }

        public Criteria andCnyPriceLessThan(Double value) {
            addCriterion("cny_price <", value, "cnyPrice");
            return (Criteria) this;
        }

        public Criteria andCnyPriceLessThanOrEqualTo(Double value) {
            addCriterion("cny_price <=", value, "cnyPrice");
            return (Criteria) this;
        }

        public Criteria andCnyPriceIn(List<Double> values) {
            addCriterion("cny_price in", values, "cnyPrice");
            return (Criteria) this;
        }

        public Criteria andCnyPriceNotIn(List<Double> values) {
            addCriterion("cny_price not in", values, "cnyPrice");
            return (Criteria) this;
        }

        public Criteria andCnyPriceBetween(Double value1, Double value2) {
            addCriterion("cny_price between", value1, value2, "cnyPrice");
            return (Criteria) this;
        }

        public Criteria andCnyPriceNotBetween(Double value1, Double value2) {
            addCriterion("cny_price not between", value1, value2, "cnyPrice");
            return (Criteria) this;
        }

        public Criteria andParentProductIdIsNull() {
            addCriterion("parent_product_id is null");
            return (Criteria) this;
        }

        public Criteria andParentProductIdIsNotNull() {
            addCriterion("parent_product_id is not null");
            return (Criteria) this;
        }

        public Criteria andParentProductIdEqualTo(Integer value) {
            addCriterion("parent_product_id =", value, "parentProductId");
            return (Criteria) this;
        }

        public Criteria andParentProductIdNotEqualTo(Integer value) {
            addCriterion("parent_product_id <>", value, "parentProductId");
            return (Criteria) this;
        }

        public Criteria andParentProductIdGreaterThan(Integer value) {
            addCriterion("parent_product_id >", value, "parentProductId");
            return (Criteria) this;
        }

        public Criteria andParentProductIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("parent_product_id >=", value, "parentProductId");
            return (Criteria) this;
        }

        public Criteria andParentProductIdLessThan(Integer value) {
            addCriterion("parent_product_id <", value, "parentProductId");
            return (Criteria) this;
        }

        public Criteria andParentProductIdLessThanOrEqualTo(Integer value) {
            addCriterion("parent_product_id <=", value, "parentProductId");
            return (Criteria) this;
        }

        public Criteria andParentProductIdIn(List<Integer> values) {
            addCriterion("parent_product_id in", values, "parentProductId");
            return (Criteria) this;
        }

        public Criteria andParentProductIdNotIn(List<Integer> values) {
            addCriterion("parent_product_id not in", values, "parentProductId");
            return (Criteria) this;
        }

        public Criteria andParentProductIdBetween(Integer value1, Integer value2) {
            addCriterion("parent_product_id between", value1, value2, "parentProductId");
            return (Criteria) this;
        }

        public Criteria andParentProductIdNotBetween(Integer value1, Integer value2) {
            addCriterion("parent_product_id not between", value1, value2, "parentProductId");
            return (Criteria) this;
        }

        public Criteria andSonIdsIsNull() {
            addCriterion("son_ids is null");
            return (Criteria) this;
        }

        public Criteria andSonIdsIsNotNull() {
            addCriterion("son_ids is not null");
            return (Criteria) this;
        }

        public Criteria andSonIdsEqualTo(String value) {
            addCriterion("son_ids =", value, "sonIds");
            return (Criteria) this;
        }

        public Criteria andSonIdsNotEqualTo(String value) {
            addCriterion("son_ids <>", value, "sonIds");
            return (Criteria) this;
        }

        public Criteria andSonIdsGreaterThan(String value) {
            addCriterion("son_ids >", value, "sonIds");
            return (Criteria) this;
        }

        public Criteria andSonIdsGreaterThanOrEqualTo(String value) {
            addCriterion("son_ids >=", value, "sonIds");
            return (Criteria) this;
        }

        public Criteria andSonIdsLessThan(String value) {
            addCriterion("son_ids <", value, "sonIds");
            return (Criteria) this;
        }

        public Criteria andSonIdsLessThanOrEqualTo(String value) {
            addCriterion("son_ids <=", value, "sonIds");
            return (Criteria) this;
        }

        public Criteria andSonIdsLike(String value) {
            addCriterion("son_ids like", value, "sonIds");
            return (Criteria) this;
        }

        public Criteria andSonIdsNotLike(String value) {
            addCriterion("son_ids not like", value, "sonIds");
            return (Criteria) this;
        }

        public Criteria andSonIdsIn(List<String> values) {
            addCriterion("son_ids in", values, "sonIds");
            return (Criteria) this;
        }

        public Criteria andSonIdsNotIn(List<String> values) {
            addCriterion("son_ids not in", values, "sonIds");
            return (Criteria) this;
        }

        public Criteria andSonIdsBetween(String value1, String value2) {
            addCriterion("son_ids between", value1, value2, "sonIds");
            return (Criteria) this;
        }

        public Criteria andSonIdsNotBetween(String value1, String value2) {
            addCriterion("son_ids not between", value1, value2, "sonIds");
            return (Criteria) this;
        }

        public Criteria andDisplayPriceIsNull() {
            addCriterion("display_price is null");
            return (Criteria) this;
        }

        public Criteria andDisplayPriceIsNotNull() {
            addCriterion("display_price is not null");
            return (Criteria) this;
        }

        public Criteria andDisplayPriceEqualTo(BigDecimal value) {
            addCriterion("display_price =", value, "displayPrice");
            return (Criteria) this;
        }

        public Criteria andDisplayPriceNotEqualTo(BigDecimal value) {
            addCriterion("display_price <>", value, "displayPrice");
            return (Criteria) this;
        }

        public Criteria andDisplayPriceGreaterThan(BigDecimal value) {
            addCriterion("display_price >", value, "displayPrice");
            return (Criteria) this;
        }

        public Criteria andDisplayPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("display_price >=", value, "displayPrice");
            return (Criteria) this;
        }

        public Criteria andDisplayPriceLessThan(BigDecimal value) {
            addCriterion("display_price <", value, "displayPrice");
            return (Criteria) this;
        }

        public Criteria andDisplayPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("display_price <=", value, "displayPrice");
            return (Criteria) this;
        }

        public Criteria andDisplayPriceIn(List<BigDecimal> values) {
            addCriterion("display_price in", values, "displayPrice");
            return (Criteria) this;
        }

        public Criteria andDisplayPriceNotIn(List<BigDecimal> values) {
            addCriterion("display_price not in", values, "displayPrice");
            return (Criteria) this;
        }

        public Criteria andDisplayPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("display_price between", value1, value2, "displayPrice");
            return (Criteria) this;
        }

        public Criteria andDisplayPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("display_price not between", value1, value2, "displayPrice");
            return (Criteria) this;
        }

        public Criteria andCnyDisplayPriceIsNull() {
            addCriterion("cny_display_price is null");
            return (Criteria) this;
        }

        public Criteria andCnyDisplayPriceIsNotNull() {
            addCriterion("cny_display_price is not null");
            return (Criteria) this;
        }

        public Criteria andCnyDisplayPriceEqualTo(BigDecimal value) {
            addCriterion("cny_display_price =", value, "cnyDisplayPrice");
            return (Criteria) this;
        }

        public Criteria andCnyDisplayPriceNotEqualTo(BigDecimal value) {
            addCriterion("cny_display_price <>", value, "cnyDisplayPrice");
            return (Criteria) this;
        }

        public Criteria andCnyDisplayPriceGreaterThan(BigDecimal value) {
            addCriterion("cny_display_price >", value, "cnyDisplayPrice");
            return (Criteria) this;
        }

        public Criteria andCnyDisplayPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("cny_display_price >=", value, "cnyDisplayPrice");
            return (Criteria) this;
        }

        public Criteria andCnyDisplayPriceLessThan(BigDecimal value) {
            addCriterion("cny_display_price <", value, "cnyDisplayPrice");
            return (Criteria) this;
        }

        public Criteria andCnyDisplayPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("cny_display_price <=", value, "cnyDisplayPrice");
            return (Criteria) this;
        }

        public Criteria andCnyDisplayPriceIn(List<BigDecimal> values) {
            addCriterion("cny_display_price in", values, "cnyDisplayPrice");
            return (Criteria) this;
        }

        public Criteria andCnyDisplayPriceNotIn(List<BigDecimal> values) {
            addCriterion("cny_display_price not in", values, "cnyDisplayPrice");
            return (Criteria) this;
        }

        public Criteria andCnyDisplayPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("cny_display_price between", value1, value2, "cnyDisplayPrice");
            return (Criteria) this;
        }

        public Criteria andCnyDisplayPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("cny_display_price not between", value1, value2, "cnyDisplayPrice");
            return (Criteria) this;
        }

        public Criteria andNameLikeInsensitive(String value) {
            addCriterion("upper(name) like", value.toUpperCase(), "name");
            return (Criteria) this;
        }

        public Criteria andCodeLikeInsensitive(String value) {
            addCriterion("upper(code) like", value.toUpperCase(), "code");
            return (Criteria) this;
        }

        public Criteria andForVersionLikeInsensitive(String value) {
            addCriterion("upper(for_version) like", value.toUpperCase(), "forVersion");
            return (Criteria) this;
        }

        public Criteria andForPeriodLikeInsensitive(String value) {
            addCriterion("upper(for_period) like", value.toUpperCase(), "forPeriod");
            return (Criteria) this;
        }

        public Criteria andDescriptionLikeInsensitive(String value) {
            addCriterion("upper(description) like", value.toUpperCase(), "description");
            return (Criteria) this;
        }

        public Criteria andSonIdsLikeInsensitive(String value) {
            addCriterion("upper(son_ids) like", value.toUpperCase(), "sonIds");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {
        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}
