package cn.kdan.pdf.tech.core.params;

import lombok.Data;

import java.util.List;

/**
 * 注册
 * @author tangxiangan
 */
@Data
public class VppMemberRegisterParam {
    private String username;

    private String password;

    private String confirmPassword;

    private String email;

    private String verifyCode;

    private String industry;

    private String company;

    /**
     * 添加管理员时，如果邮箱未注册需要先注册，直接加入团队
     */
    private List<String> teamIds;

    /**
     * 通过邮件连接注册管理员的时候，邮件附带的code，用于判断邮件的有效性
     */
    private String inviteEmailCode;

    private Boolean isSuperAdmin;

    private String area;
}
