package cn.kdan.pdf.tech.core.aspect;

import cn.kdan.pdf.tech.core.enums.RoleEnum;

import java.lang.annotation.*;

@Documented
@Target(ElementType.METHOD)
@Retention(RetentionPolicy.RUNTIME)
public @interface PreCheckRole {

    // 哪些角色可以访问该接口
    RoleEnum[] roles() default {RoleEnum.SUPER_ADMIN, RoleEnum.TEAM_MEMBER, RoleEnum.TEAM_ADMIN};

    //团队id
    String resourceId() default "";
}
