package cn.kdan.pdf.tech.core.controller;

import cn.kdan.pdf.tech.core.pojo.dto.SetGeneralDTO;
import cn.kdan.pdf.tech.core.service.VppSetService;
import constant.CommonConstant;
import org.springframework.web.bind.annotation.*;
import pojo.ResultMap;

import javax.annotation.Resource;
import javax.validation.Valid;

/**
 * @author Bob
 */
@RestController
@RequestMapping("/vppSet")
public class VppSetController {

    @Resource
    private VppSetService vppSetService;

    /**
     * 设置用户信息
     * @return
     */
    @PutMapping("/setGeneral")
    public ResultMap<Boolean> setGeneral(@RequestBody @Valid SetGeneralDTO dto) {
        vppSetService.setGeneral(dto);
        return new ResultMap<>(CommonConstant.SUCCESS, CommonConstant.RESULT_SUCCESS, Boolean.TRUE);
    }

//    /**
//     * 设置用户密码
//     * @return
//     */
//    @PutMapping("/setSecurity")
//    public ResultMap<Boolean> setSecurity(SetSecurityDTO dto) {
//        vppSetService.setSecurity(dto);
//        return new ResultMap<>(CommonConstant.SUCCESS, CommonConstant.RESULT_SUCCESS, Boolean.TRUE);
//    }

}
