package cn.kdan.pdf.tech.core.mapper.ext;

import cn.kdan.pdf.tech.core.mapper.ProductsMapper;
import cn.kdan.pdf.tech.core.pojo.vo.ProductListVO;
import cn.kdan.pdf.tech.core.pojo.vo.ProductSimpleVO;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author tangxiangan
 */
public interface ExtProductMapper extends ProductsMapper {

    /**
     * 获取团队的产品列表
     *
     * @param teamId  团队id
     * @return List
     */
    List<ProductSimpleVO> listWithSimpleInfo(@Param("teamId") String teamId);

    List<ProductListVO> listWithAdmin(@Param("teamIds") List<String> teamId);

    List<ProductListVO> listWithAll(@Param("companyId") String companyId);

}
