package cn.kdan.pdf.tech.core.pojo.dto;

import lombok.Data;

import javax.validation.constraints.NotEmpty;

/**
 * @desc 设置用户信息请求实体类
 * @author Bob
 */
@Data
public class SetGeneralDTO {

    /**
     * 用户名
     */
    @NotEmpty(message = "Missing required information")
    private String userName;

    /**
     * 地区
     */
    private String area;

}
