package cn.kdan.pdf.tech.core.pojo.oauth2;

import cn.kdan.pdf.tech.core.utils.RSAUtils;
import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
import org.springframework.security.crypto.password.PasswordEncoder;
import utils.AesUtils;

public class LoginPasswordEncoder implements PasswordEncoder {

    @Override
    public boolean matches(CharSequence rawPassword, String encodedPassword) {
        //加密之后对比密码
        RSAUtils rsaUtils = new RSAUtils();
        String pwd = rsaUtils.decrypt(encodedPassword);
        return pwd.equals(rawPassword);
//        BCryptPasswordEncoder encoder = new BCryptPasswordEncoder();
//        return encoder.matches(rawPassword, encodedPassword);
    }

    @Override
    public String encode(CharSequence rawPassword) {
        RSAUtils rsaUtils = new RSAUtils();
        return rsaUtils.encrypt(rawPassword.toString());
//        BCryptPasswordEncoder encoder = new BCryptPasswordEncoder();
//        return encoder.encode(rawPassword);
    }
}
