package cn.kdan.pdf.tech.core.service;


import cn.kdan.pdf.tech.core.model.Subscriptions;
import cn.kdan.pdf.tech.core.pojo.vo.SubscriptionResellerVO;
import cn.kdan.pdf.tech.core.pojo.vo.SubscriptionVO;
import com.github.pagehelper.PageInfo;


/**
 * service
 *
 * @author tangxiangan
 */
public interface SubscriptionService {

    /**
     * 获取当前登录用户所在公司的产品购买情况
     *
     * @param page     页码
     * @param pageSize 最大条数
     * @param code    code
     * @return list
     */
    PageInfo<SubscriptionVO> pageByCompany(Integer page, Integer pageSize, String code);

    PageInfo<SubscriptionResellerVO> pageForReseller(Integer page, Integer pageSize, String code);

    Subscriptions getById(String id);
}
